config/routes.rb
# frozen_string_literal: true
Rails.application.routes.draw do
  resources :organizations

  resources :organizations, only: [] do
    resources :item_types do
      get 'graph_map', controller: 'states'
    end

    resources :item_types, only: [], path: '' do
      match 'summary', to: 'item_types#summary', via: :get
      resources :states
      resources :items, path: ''
    end
  end

  root 'home#index'
  match 'home/private_index' => 'home#private_index', via: :get

  # omniauth
  get '/auth/:provider/callback' => 'user_sessions#create'
  get '/auth/failure' => 'user_sessions#failure'
  get 'auth/autologin' => 'user_sessions#autologin'

  # Custom logout
  match '/logout', to: 'user_sessions#destroy', via: :all
end

app/controllers/item_types_controller.rb
# frozen_string_literal: true
class ItemTypesController < ApplicationController
  before_action :set_organization
  before_action :set_item_type, only: [:show, :edit, :update, :destroy, :summary]

  # GET /item_types
  # GET /item_types.json
  def index
    @item_types = @organization.item_types.all
  end

  # GET /item_types/1
  # GET /item_types/1.json
  def show; end

  # GET /item_types/new
  def new
    @item_type = ItemType.new
  end

  # GET /item_types/1/edit
  def edit; end

  # POST /item_types
  # POST /item_types.json
  def create
    @item_type = ItemType.new(item_type_params)
    @item_type.organization = @organization
    @item_type.sample_state_service = params[:post_service]

    respond_to do |format|
      if @item_type.save
        format.html do
          redirect_to [@organization, @item_type],
                      notice: 'Item type was successfully created.'
        end
        format.json { render :show, status: :created, location: [@organization, @item_type] }
      else
        format.html { render :new }
        format.json { render json: @item_type.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /item_types/1
  # PATCH/PUT /item_types/1.json
  def update
    respond_to do |format|
      if @item_type.update(item_type_params)
        format.html do
          redirect_to [@organization, @item_type],
                      notice: 'Item type was successfully updated.'
        end
        format.json { render :show, status: :ok, location: [@organization, @item_type] }
      else
        format.html { render :edit }
        format.json { render json: @item_type.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /item_types/1
  # DELETE /item_types/1.json
  def destroy
    @item_type.destroy
    respond_to do |format|
      format.html do
        redirect_to organization_item_types_url(@organization),
                    notice: 'item type was successfully destroyed.'
      end
      format.json { head :no_content }
    end
  end

  def summary
    @state_items_count = @item_type.items.group('state').count
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_item_type
    @item_type = @organization.item_types.friendly.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def item_type_params
    params.require(:item_type).permit(:title, :initial_state_id)
  end
end

app/helpers/item_types_helper.rb
# frozen_string_literal: true
module ItemTypesHelper
end

app/views/item_types/_form.html.haml
= form_for [@organization, item_type] do |f|
  - if item_type.errors.any?
    #error-explanation
      %h2
        = pluralize(item_type.errors.count, 'error')
        prohibited this item_type from being saved:
      %ul
        - item_type.errors.full_messages.each do |msg|
          %li= msg

  .field
    = f.label :title
    = f.text_field :title, disabled: action_name != 'new'
  - unless item_type.states.empty?
    .field
      = f.label :initial_state
      = f.collection_select :initial_state_id, item_type.states, :id, :name
  .actions
    = f.submit 'Save'

app/views/item_types/edit.html.haml
%h1 Editing item type

= render 'form', item_type: @item_type

= link_to 'Show', [@organization, @item_type]
\|
= link_to 'All item types', organization_item_types_path(@organization)

app/views/item_types/index.html.haml
%p#alert= alert
%h1 Listing item types
%h2= @organization.name

%table
  %thead
    %tr
      %th Title
      %th
      %th
      %th

  %tbody
    - @item_types.each do |item_type|
      %tr
        %td= item_type.title
        %td= link_to 'Show', [@organization, item_type]
        %td= link_to 'Edit', edit_organization_item_type_path(@organization,
        item_type)
        %td= link_to 'Destroy', [@organization, item_type], method: :delete,
        data: { confirm: 'Are you sure?' }

%br

= link_to 'New item type', new_organization_item_type_path(@organization)
%br
= link_to 'Organization (back)', @organization

app/views/item_types/new.html.haml
%h1 New item type

= render 'form', item_type: @item_type

= link_to 'All item_types', organization_item_types_path(@organization)

app/views/item_types/show.html.haml
%p#notice= notice

%p
  %b Title:
  = @item_type.title

= link_to "New #{@item_type.title}",
new_organization_item_type_item_path(@organization, @item_type)
\|
= link_to "All #{@item_type.title}",
organization_item_type_items_path(@organization, @item_type)
%br
= link_to 'States', organization_item_type_states_path(@organization,
@item_type)
%br
= link_to 'Edit', edit_organization_item_type_path(@organization, @item_type)
\|
= link_to 'All item types', organization_item_types_path(@organization)

%p
  %b States:
  #state-graph

:javascript
  window.draw_state_graph()